##############################################################################
# 
# Zope Public License (ZPL) Version 1.0
# -------------------------------------
# 
# Copyright (c) Digital Creations.  All rights reserved.
# 
# This license has been certified as Open Source(tm).
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
# 1. Redistributions in source code must retain the above copyright
#    notice, this list of conditions, and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions, and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
# 
# 3. Digital Creations requests that attribution be given to Zope
#    in any manner possible. Zope includes a "Powered by Zope"
#    button that is installed by default. While it is not a license
#    violation to remove this button, it is requested that the
#    attribution remain. A significant investment has been put
#    into Zope, and this effort will continue if the Zope community
#    continues to grow. This is one way to assure that growth.
# 
# 4. All advertising materials and documentation mentioning
#    features derived from or use of this software must display
#    the following acknowledgement:
# 
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
# 
#    In the event that the product being advertised includes an
#    intact Zope distribution (with copyright and license included)
#    then this clause is waived.
# 
# 5. Names associated with Zope or Digital Creations must not be used to
#    endorse or promote products derived from this software without
#    prior written permission from Digital Creations.
# 
# 6. Modified redistributions of any form whatsoever must retain
#    the following acknowledgment:
# 
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
# 
#    Intact (re-)distributions of any official Zope release do not
#    require an external acknowledgement.
# 
# 7. Modifications are encouraged but must be packaged separately as
#    patches to official Zope releases.  Distributions that do not
#    clearly separate the patches from the original work must be clearly
#    labeled as unofficial distributions.  Modifications which do not
#    carry the name Zope may be packaged in any form, as long as they
#    conform to all of the clauses above.
# 
# 
# Disclaimer
# 
#   THIS SOFTWARE IS PROVIDED BY DIGITAL CREATIONS ``AS IS'' AND ANY
#   EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL DIGITAL CREATIONS OR ITS
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# 
# 
# This software consists of contributions made by Digital Creations and
# many individuals on behalf of Digital Creations.  Specific
# attributions are listed in the accompanying credits file.
# 
##############################################################################

"""
    News Tag product - E-Commerce Times File Decoder
    
File Format:

^^setSpeed (90)
^^setBackgroundColor (0,156,222)
^^setForegroundColor (0,0,0)
^^setFontFace (arial)
^^setFontSize (11)
^^setCenter (false)
^^setBold (false)

^^setForegroundColor (0, 0, 0)
^^setURL(http://www.ecommercetimes.com)


^^setCenter (true)

^^setForegroundColor (255, 255, 255)
^^setFontFace (arial)
^^setFontSize (12)
^^setBold (true)
^^setCenter (true)
Brought To You By
The
E-Commerce Times
^^setForegroundColor (255, 255, 255)

^^setCenter (true)
^^pause (2500)

^^setCenter (true)


TechNewsWorld.com
^^setForegroundColor (0, 0, 0)
^^setFontFace (arial)
^^setFontSize (11)
^^setBold (false)
Click Here For
Up to the Minute
News Updates From
Around the World
^^setURL(http://www.technewsworld.com)
^^setCenter (true)
^^pause (3500)
^^setForegroundColor (255, 255, 255)
^^setFontFace (arial)
^^setFontSize (12)
^^setBold (true)
^^setCenter (true)
"""
__version__ = "1.0"

from string import strip, split
import re
import BaseParser

class ECT(BaseParser.BaseParser):
    """ """
    name = 'ECT'
    server = 'www.ecommercetimes.com'
    sources = {
        'default': '/ticker_headlines/headlines-1.txt ',
    }
    
    def close(self):
        """ """
        splitterRE = re.compile('\^\^pause.*?\(.*?\).*?\n', re.I | re.M | re.S)
        urlRE = re.compile('.*\^\^setURL.*?[(](.*?)[)].*?\n', re.I | re.M | re.S)
        self.data = re.sub('[\r\n]+', '\n', self.data)
        sifted = splitterRE.split(self.data)
        for Item in sifted:
            urlM = urlRE.match(Item)
            if urlM:
                url = urlM.group(1)
            headline = ''
            body = ''
            inSect = 0  # 0=none, 1=Head, 2=None, 3=Body, 4=none
            for Line in split(Item, '\n'):
                Line = re.sub('\n', '', Line)
                Line = strip(Line)
                if not Line:
                    pass
                elif Line[:2] == '^^':
                    if inSect == 0:
                        pass
                    elif inSect == 1:
                        inSect = 2
                        pass
                    elif inSect == 3:
                        inSect = 4
                        pass
                else:
                    if inSect == 0 or inSect == 1:
                        inSect = 1
                        headline = headline + ' ' + Line
                    elif inSect == 2 or inSect == 3:
                        inSect = 3
                        body = body + ' ' + Line
            self.Stories.append({'url': url, 'headline': strip(headline), 'body': strip(body)})
